package cn.iocoder.byzs.module.bjdx.service.questionnaireresult;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import cn.iocoder.byzs.module.bjdx.controller.admin.questionnaireresult.vo.*;
import cn.iocoder.byzs.module.bjdx.dal.dataobject.questionnaireresult.QuestionnaireResultDO;
import cn.iocoder.byzs.framework.common.pojo.PageResult;
import cn.iocoder.byzs.framework.common.util.object.BeanUtils;

import cn.iocoder.byzs.module.bjdx.dal.mysql.questionnaireresult.QuestionnaireResultMapper;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.framework.common.util.collection.CollectionUtils.convertList;
import static cn.iocoder.byzs.module.bjdx.enums.ErrorCodeConstants.*;

/**
 * 北京大学-问卷结果 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class QuestionnaireResultServiceImpl implements QuestionnaireResultService {

    @Resource
    private QuestionnaireResultMapper questionnaireResultMapper;

    @Override
    public Long createQuestionnaireResult(QuestionnaireResultSaveReqVO createReqVO) {
        // 插入
        QuestionnaireResultDO questionnaireResult = BeanUtils.toBean(createReqVO, QuestionnaireResultDO.class);
        questionnaireResultMapper.insert(questionnaireResult);
        // 返回
        return questionnaireResult.getId();
    }

    @Override
    public void updateQuestionnaireResult(QuestionnaireResultSaveReqVO updateReqVO) {
        // 校验存在
        validateQuestionnaireResultExists(updateReqVO.getId());
        // 更新
        QuestionnaireResultDO updateObj = BeanUtils.toBean(updateReqVO, QuestionnaireResultDO.class);
        questionnaireResultMapper.updateById(updateObj);
    }

    @Override
    public void deleteQuestionnaireResult(Long id) {
        // 校验存在
        validateQuestionnaireResultExists(id);
        // 删除
        questionnaireResultMapper.deleteById(id);
    }

    @Override
        public void deleteQuestionnaireResultListByIds(List<Long> ids) {
        // 校验存在
        validateQuestionnaireResultExists(ids);
        // 删除
        questionnaireResultMapper.deleteByIds(ids);
        }

    private void validateQuestionnaireResultExists(List<Long> ids) {
        List<QuestionnaireResultDO> list = questionnaireResultMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(QUESTIONNAIRE_RESULT_NOT_EXISTS);
        }
    }

    private void validateQuestionnaireResultExists(Long id) {
        if (questionnaireResultMapper.selectById(id) == null) {
            throw exception(QUESTIONNAIRE_RESULT_NOT_EXISTS);
        }
    }

    @Override
    public QuestionnaireResultDO getQuestionnaireResult(Long id) {
        return questionnaireResultMapper.selectById(id);
    }

    @Override
    public PageResult<QuestionnaireResultDO> getQuestionnaireResultPage(QuestionnaireResultPageReqVO pageReqVO) {
        return questionnaireResultMapper.selectPage(pageReqVO);
    }

}